<mat-expansion-panel>
  <mat-expansion-panel-header>
    <mat-panel-title> MITRE ATT&CK Techniques </mat-panel-title>
    <mat-panel-description>
      <span *ngIf="mitreTechniques.length > 0; else noTechniquesLabel">
        This level contains {{ mitreTechniques.length }} techniques(s)</span
      >
      <ng-template #noTechniquesLabel>
        <span>This level has no techniques</span>
      </ng-template>
    </mat-panel-description>
  </mat-expansion-panel-header>
  <mat-form-field class="chip-list" appearance="outline">
    <mat-label>Techniques</mat-label>
    <mat-chip-grid #chipList [formControl]="chipListCtrl">
      <mat-chip-row
        *ngFor="let mitreTechnique of mitreTechniques"
        (removed)="remove(mitreTechnique)"
        class="mat-chip-selected"
      >
        {{ mitreTechnique.techniqueKey }}
        <button matChipRemove>
          <mat-icon>cancel</mat-icon>
        </button>
      </mat-chip-row>
      <input
        mat-input
        #techniqueInput
        placeholder="New technique..."
        [matAutocomplete]="auto"
        [matChipInputFor]="chipList"
        [matChipInputSeparatorKeyCodes]="separatorKeysCodes"
        [matChipInputAddOnBlur]="true"
        (matChipInputTokenEnd)="add($event)"
        (paste)="paste($event)"
        (input)="onInput($event)"
      />
    </mat-chip-grid>
    <mat-autocomplete #auto="matAutocomplete" (optionSelected)="selected($event)">
      <mat-option *ngFor="let mitreTechnique of filteredTechniquesList" [value]="mitreTechnique">
        {{ mitreTechnique.techniqueKey }} - {{ mitreTechnique.techniqueName }}
      </mat-option>
    </mat-autocomplete>
    <mat-hint
      >Techniques must be in format: &#60;TACTIC_ID.TECHNIQUE_ID&#62;. Ids of tactics and techniques can be found on
      https://attack.mitre.org/matrices/enterprise/
    </mat-hint>
    <mat-error *ngIf="chipListCtrl.hasError('wrongFormat')"> Wrong format!</mat-error>
  </mat-form-field>
</mat-expansion-panel>
